package hal

type MultiThreadedIO struct {
	channel chan float64
}

func NewMultiThreadedIO() *MultiThreadedIO {
	return &MultiThreadedIO{
		channel: make(chan float64),
	}
}

func (io *MultiThreadedIO) Read() (float64, error) {
	result := <-io.channel
	return result, nil
}

func (io *MultiThreadedIO) Write(content float64) error {
	io.channel <- content
	return nil
}
