package hal

import (
	"fmt"
	"os"
	"time"
)

type PageErrorLogger struct {
	file *os.File
}

func NewPageErrorLogger(path string) (logger *PageErrorLogger, err error) {
	logger = new(PageErrorLogger)
	os.Remove(path)
	logger.file, err = os.Create(path)
	return
}

func (logger *PageErrorLogger) handlePageError(address Address, write bool) {
	fmt.Fprintf(logger.file, "[timestamp = %s addr = 0x%X write=%t]\n", time.Now().String(), address, write)
}

func (logger *PageErrorLogger) Close() error {
	return logger.file.Close()
}
